django_airavata/apps/workspace/urls.py
from django.urls import re_path

from . import views

app_name = 'django_airavata_workspace'
urlpatterns = [
    re_path(r'^projects$', views.projects_list, name='projects'),
    re_path(r'^projects/(?P<project_id>[^/]+)/$', views.edit_project,
            name='edit_project'),
    re_path(r'^experiments/(?P<experiment_id>[^/]+)/edit$', views.edit_experiment,
            name='edit_experiment'),
    re_path(r'^experiments/(?P<experiment_id>[^/]+)/$', views.view_experiment,
            name='view_experiment'),
    re_path(r'^experiments$', views.experiments_list, name='experiments'),
    re_path(r'^applications/(?P<app_module_id>[^/]+)/create_experiment$',
            views.create_experiment, name='create_experiment'),
    re_path(r'^dashboard$', views.dashboard, name='dashboard'),
    re_path(r'^storage', views.user_storage, name='storage'),
]

django_airavata/urls.py
from django.conf import settings
from django.conf.urls import include
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path, re_path
from wagtail.admin import urls as wagtailadmin_urls
from wagtail.core import urls as wagtail_urls
from wagtail.documents import urls as wagtaildocs_urls

from . import views

urlpatterns = [
    re_path(r'^djadmin/', admin.site.urls),
    re_path(r'^admin/', include('django_airavata.apps.admin.urls')),
    re_path(r'^auth/', include('django_airavata.apps.auth.urls')),
    re_path(r'^workspace/', include('django_airavata.apps.workspace.urls')),
    re_path(r'^api/', include('django_airavata.apps.api.urls')),
    re_path(r'^groups/', include('django_airavata.apps.groups.urls')),
    re_path(r'^dataparsers/', include('django_airavata.apps.dataparsers.urls')),
    path('sdk/', include('airavata_django_portal_sdk.urls')),
    re_path(r'^home$', views.home, name='home'),
    re_path(r'^cms/', include(wagtailadmin_urls)),
    re_path(r'^documents/', include(wagtaildocs_urls)),
    # For testing, developing error pages
    re_path(r'^400/', views.error400),
    re_path(r'^403/', views.error403),
    re_path(r'^404/', views.error404),
    re_path(r'^500/', views.error500),
    path('', include('airavata_django_portal_commons.dynamic_apps.urls')),
    path('', include(wagtail_urls)),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

handler400 = views.error400
handler403 = views.error403
handler404 = views.error404
handler500 = views.error500

django_airavata/apps/workspace/models.py
# Create your models here.

django_airavata/apps/workspace/views.py
import json
import logging
from urllib.parse import urlparse

from airavata.model.application.io.ttypes import DataType
from airavata_django_portal_sdk import user_storage as user_storage_sdk
from django.contrib.auth.decorators import login_required
from django.shortcuts import render
from django.utils.module_loading import import_string
from rest_framework.renderers import JSONRenderer

from django_airavata.apps.api import models
from django_airavata.apps.api.views import (
    ApplicationModuleViewSet,
    ExperimentSearchViewSet,
    FullExperimentViewSet,
    ProjectViewSet
)

logger = logging.getLogger(__name__)


@login_required
def experiments_list(request):
    request.active_nav_item = 'experiments'

    response = ExperimentSearchViewSet.as_view({'get': 'list'})(request)
    if response.status_code != 200:
        raise Exception("Failed to load experiments list: {}".format(
            response.data['detail']))
    experiments_json = JSONRenderer().render(response.data).decode('utf-8')
    return render(request, 'django_airavata_workspace/experiments_list.html', {
        'bundle_name': 'experiment-list',
        'experiments_data': experiments_json
    })


@login_required
def dashboard(request):
    request.active_nav_item = 'dashboard'
    return render(request, 'django_airavata_workspace/dashboard.html', {
        'bundle_name': 'dashboard',
        'sidebar': True,
    })


@login_required
def projects_list(request):
    request.active_nav_item = 'projects'

    response = ProjectViewSet.as_view({'get': 'list'})(request)
    if response.status_code != 200:
        raise Exception("Failed to load projects list: {}".format(
            response.data['detail']))
    projects_json = JSONRenderer().render(response.data).decode('utf-8')

    return render(request, 'django_airavata_workspace/projects_list.html', {
        'bundle_name': 'project-list',
        'projects_data': projects_json
    })


@login_required
def edit_project(request, project_id):
    request.active_nav_item = 'projects'

    return render(request, 'django_airavata_workspace/edit_project.html', {
        'bundle_name': 'edit-project',
        'project_id': project_id
    })


@login_required
def create_experiment(request, app_module_id):
    request.active_nav_item = 'dashboard'

    # User input files can be passed as query parameters
    # <input name>=<path/to/user_file>
    # and also as data product URIs
    # <input name>=<data product URI>
    app_interface = ApplicationModuleViewSet.as_view(
        {'get': 'application_interface'})(request, app_module_id=app_module_id)
    if app_interface.status_code != 200:
        raise Exception("Failed to load application module data: {}".format(
            app_interface.data['detail']))
    user_input_values = {}
    for app_input in app_interface.data['applicationInputs']:
        if (app_input['type'] ==
                DataType.URI and app_input['name'] in request.GET):
            user_file_value = request.GET[app_input['name']]
            try:
                user_file_url = urlparse(user_file_value)
                if user_file_url.scheme == 'airavata-dp':
                    dp_uri = user_file_value
                    try:
                        data_product = request.airavata_client.getDataProduct(
                            request.authz_token, dp_uri)
                        if user_storage_sdk.exists(request, data_product):
                            user_input_values[app_input['name']] = dp_uri
                    except Exception:
                        logger.exception(
                            f"Failed checking data product uri: {dp_uri}", extra={'request': request})
            except ValueError:
                logger.exception(f"Invalid user file value: {user_file_value}", extra={'request': request})
        elif (app_input['type'] == DataType.STRING and
              app_input['name'] in request.GET):
            name = app_input['name']
            user_input_values[name] = request.GET[name]
    context = {
        'bundle_name': 'create-experiment',
        'app_module_id': app_module_id,
        'user_input_values': json.dumps(user_input_values)
    }
    if 'experiment-data-dir' in request.GET:
        context['experiment_data_dir'] = request.GET['experiment-data-dir']

    template_path = 'django_airavata_workspace/create_experiment.html'
    # Apply a custom application template if it exists
    custom_template_path, custom_context = get_custom_template(request, app_module_id)
    if custom_template_path is not None:
        logger.debug(f"Applying custom application template {custom_template_path}")
        template_path = custom_template_path
        context.update(custom_context)

    return render(request, template_path, context)


@login_required
def edit_experiment(request, experiment_id):
    request.active_nav_item = 'experiments'

    experiment = request.airavata_client.getExperiment(request.authz_token, experiment_id)
    applicationInterface = request.airavata_client.getApplicationInterface(request.authz_token, experiment.executionId)
    app_module_id = applicationInterface.applicationModules[0]
    context = {
        'bundle_name': 'edit-experiment',
        'experiment_id': experiment_id,
        'app_module_id': app_module_id,
    }
    template_path = 'django_airavata_workspace/edit_experiment.html'
    # Apply a custom application template if it exists
    custom_template_path, custom_context = get_custom_template(request, app_module_id)
    if custom_template_path is not None:
        logger.debug(f"Applying custom application template {custom_template_path}")
        template_path = custom_template_path
        context.update(custom_context)

    return render(request, template_path, context)


def get_custom_template(request, app_module_id):
    template_path = None
    context = {}
    query = models.ApplicationTemplate.objects.filter(application_module_id=app_module_id)
    if query.exists():
        application_template = query.get()
        template_path = application_template.template_path
        for context_processor in application_template.context_processors.all():
            context_processor = import_string(context_processor.callable_path)
            context.update(context_processor(request))
    return template_path, context


@login_required
def view_experiment(request, experiment_id):
    request.active_nav_item = 'experiments'

    launching = json.loads(request.GET.get('launching', 'false'))
    response = FullExperimentViewSet.as_view(
        {'get': 'retrieve'})(request, experiment_id=experiment_id)
    if response.status_code != 200:
        raise Exception("Failed to load experiment data: {}".format(
            response.data['detail']))
    full_experiment_json = JSONRenderer().render(response.data).decode('utf-8')

    return render(request, 'django_airavata_workspace/view_experiment.html', {
        'bundle_name': 'view-experiment',
        'full_experiment_data': full_experiment_json,
        'launching': json.dumps(launching),
    })


@login_required
def user_storage(request):
    request.active_nav_item = 'storage'
    return render(request, 'django_airavata_workspace/base.html', {
        'bundle_name': 'user-storage'
    })

django_airavata/apps/workspace/templates/django_airavata_workspace/base.html
{% extends 'base.html' %}

{% load static %}
{% load render_bundle from webpack_loader %}

{% block css %}
{% render_bundle 'chunk-vendors' 'css' 'WORKSPACE' %}
{% render_bundle 'chunk-common' 'css' 'WORKSPACE' %}
{% render_bundle bundle_name 'css' 'WORKSPACE' %}
{% endblock %}

{% block content %}
<div id="{{ bundle_name }}"/>
{% endblock content %}

{% block scripts %}
{% render_bundle 'chunk-vendors' 'js' 'WORKSPACE' %}
{% render_bundle 'chunk-common' 'js' 'WORKSPACE' %}
{% render_bundle bundle_name 'js' 'WORKSPACE' %}
{% endblock %}

django_airavata/apps/workspace/templates/django_airavata_workspace/create_experiment.html
{% extends './base.html' %}

{% block content %}

<div id="{{ bundle_name }}" data-app-module-id="{{ app_module_id }}" data-user-input-values="{{ user_input_values }}"
  {% if experiment_data_dir %}data-experiment-data-dir="{{ experiment_data_dir }}"{% endif %}
>
</div>

{% endblock content %}

django_airavata/apps/workspace/templates/django_airavata_workspace/dashboard.html
{% extends './base.html' %}

{% load render_bundle from webpack_loader %}

{% block content %}
<div id="dashboard" data-view-all-experiments="{% url 'django_airavata_workspace:experiments' %}" data-username="{{ request.user.username }}" />
{% endblock content %}

django_airavata/apps/workspace/templates/django_airavata_workspace/edit_experiment.html
{% extends './base.html' %}

{% block content %}

<div id="{{ bundle_name }}" data-experiment-id="{{ experiment_id }}"></div>

{% endblock content %}

django_airavata/apps/workspace/templates/django_airavata_workspace/edit_project.html
{% extends './base.html' %}

{% block content %}

<div id="{{ bundle_name }}" data-project-id="{{ project_id }}"></div>

{% endblock content %}

django_airavata/apps/workspace/templates/django_airavata_workspace/experiments_list.html
{% extends './base.html' %}

{% block content %}

<div id="{{ bundle_name }}" data-experiments-data="{{ experiments_data }}"></div>

{% endblock content %}

django_airavata/apps/workspace/templates/django_airavata_workspace/projects_list.html
{% extends './base.html' %}

{% block content %}

<div id="{{ bundle_name }}" data-projects-data="{{ projects_data }}"></div>

{% endblock content %}

django_airavata/apps/workspace/templates/django_airavata_workspace/view_experiment.html
{% extends './base.html' %}

{% block content %}

<div id="{{ bundle_name }}" data-full-experiment-data="{{ full_experiment_data }}" data-launching="{{ launching }}"></div>

{% endblock content %}

django_airavata/apps/workspace/templates/django_airavata_workspace/wc-base.html
{% extends 'base.html' %}

{% load static %}

{% block css %}
  {% block custom-css %}
  {% endblock %}
{% endblock css %}

{% block content %}
<div class="main-content-wrapper">
    <main class="main-content">
        <div class="container-fluid">
          {% block custom-content %}

          {% endblock custom-content %}
        </div>
    </main>
</div>
{% endblock content %}

{% block scripts %}
<script src="{% static 'django_airavata_workspace/wc/adpf.chunk-vendors.js' %}"></script>
<script src="{% static 'django_airavata_workspace/wc/adpf.min.js' %}"></script>
  {% block custom-scripts %}
  {% endblock custom-scripts %}
{% endblock scripts %}